/**
 * User: Jinqn
 * @Date：2022-11-09 12:38:00
 * 修改：米拓企业建站系统 Copyright (C) 长沙米拓信息技术有限公司 (https://www.metinfo.cn). All rights reserved.
 * 上传图片对话框逻辑代码,包括tab: 远程图片/上传图片/在线图片/搜索图片
 */

 (function () {
    window.M=top.M;
    window.METLANG=top.METLANG;
    var remoteImage,
        uploadImage,
        onlineImage;
    window.getCookie=top.getCookie||top.$.cookie;
    window.setCookie=top.setCookie||top.$.cookie;
    window.onload = function () {
        initTabs();
        initAlign();
        initButtons();
    };

    /* 初始化tab标签 */
    function initTabs() {
        var tabs = $G('tabhead').children;
        for (var i = 0; i < tabs.length; i++) {
            domUtils.on(tabs[i], "click", function (e) {
                var target = e.target || e.srcElement;
                setTabFocus(target.getAttribute('data-content-id'));
            });
        }

        var img = editor.selection.getRange().getClosedNode();
        if (img && img.tagName && img.tagName.toLowerCase() == 'img') {
            setTabFocus('remote');
        } else {
            setTabFocus('upload');
        }
    }

    /* 初始化tabbody */
    function setTabFocus(id) {
        if(!id) return;
        var i, bodyId, tabs = $G('tabhead').children;
        for (i = 0; i < tabs.length; i++) {
            bodyId = tabs[i].getAttribute('data-content-id');
            if (bodyId == id) {
                domUtils.addClass(tabs[i], 'focus');
                domUtils.addClass($G(bodyId), 'focus');
            } else {
                domUtils.removeClasses(tabs[i], 'focus');
                domUtils.removeClasses($G(bodyId), 'focus');
            }
        }
        switch (id) {
            case 'remote':
                remoteImage = remoteImage || new RemoteImage();
                break;
            case 'upload':
                setAlign(editor.getOpt('imageInsertAlign'));
                uploadImage = uploadImage || new UploadImage('queueList');
                break;
            case 'online':
                setAlign(editor.getOpt('imageManagerInsertAlign'));
                onlineImage = onlineImage || new OnlineImage('imageList');
                onlineImage.reset();
                break;
        }
        var $footer=$(parent.document).find('.edui-insertimage-iframe').parents('.edui-dialog-content').eq(0).next('.edui-dialog-foot'),
            $btn_back_imgfolderlist=$footer.find('.btn-edui-img-folderlist-back');
        if(id=='online'){
            if($btn_back_imgfolderlist.length){
                $btn_back_imgfolderlist.removeClass('hide');
            }else{
                $footer.prepend('<button type="button" class="btn btn-sm btn-primary ml-2 btn-edui-img-folderlist-back"><i class="fa-reply mr-2"></i>返回文件夹列表</button>');
                $btn_back_imgfolderlist=$footer.find('.btn-edui-img-folderlist-back');
                $btn_back_imgfolderlist.click(function(event) {
                    var $breadcrumb_a=$('#online .online-breadcrumb a'),
                        breadcrumb_a_num=$breadcrumb_a.length;
                    breadcrumb_a_num>2?$breadcrumb_a.eq(breadcrumb_a_num-2).dblclick():setTabFocus('online');
                });
                $('#online .online-breadcrumb').on('click', 'a', function(event) {
                    $(this).data('path')?$(this).dblclick():setTabFocus('online');
                });
            }
            $('.alignBar-online').show();
        }else{
            $('.alignBar-online').hide();
            if($btn_back_imgfolderlist.length) $btn_back_imgfolderlist.addClass('hide');
        }
        if(id=='remote'){
            $('.alignBar').show();
        }else{
            $('.alignBar').hide();
        }
    }

    /* 初始化onok事件 */
    function initButtons() {

        dialog.onok = function () {
            var remote = false, list = [], id, tabs = $G('tabhead').children;
            for (var i = 0; i < tabs.length; i++) {
                if (domUtils.hasClass(tabs[i], 'focus')) {
                    id = tabs[i].getAttribute('data-content-id');
                    break;
                }
            }

            switch (id) {
                case 'remote':
                    list = remoteImage.getInsertList();
                    remote = true;
                    break;
                case 'upload':
                    list = uploadImage.getInsertList();
                    var count = uploadImage.getQueueCount();
                    if (count) {
                        $('.info', '#queueList').html('<span style="color:red;">' + '还有2个未上传文件'.replace(/[\d]/, count) + '</span>');
                        return false;
                    }
                    break;
                case 'online':
                    list = onlineImage.getInsertList();
                    break;
            }

            if(list) {
                editor.execCommand('insertimage', list);
                remote && editor.fireEvent("catchRemoteImage");
            }
        };
    }


    /* 初始化对其方式的点击事件 */
    function initAlign(){
        /* 点击align图标 */
        domUtils.on($G("alignIcon"), 'click', function(e){
            var target = e.target || e.srcElement;
            if(target.className && target.className.indexOf('-align') != -1) {
                setAlign(target.getAttribute('data-align'));
            }
        });
    }

    /* 设置对齐方式 */
    function setAlign(align){
        align = align || 'none';
        var aligns = $G("alignIcon").children;
        for(i = 0; i < aligns.length; i++){
            if(aligns[i].getAttribute('data-align') == align) {
                domUtils.addClass(aligns[i], 'focus');
                $G("align").value = aligns[i].getAttribute('data-align');
            } else {
                domUtils.removeClasses(aligns[i], 'focus');
            }
        }
    }
    /* 获取对齐方式 */
    function getAlign(){
        var align = $G("align").value || 'none';
        return align == 'none' ? '':align;
    }


    /* 远程图片 */
    function RemoteImage(target) {
        this.container = utils.isString(target) ? document.getElementById(target) : target;
        this.init();
    }
    RemoteImage.prototype = {
        init: function () {
            this.initContainer();
            this.initEvents();
        },
        initContainer: function () {
            this.dom = {
                url: $G('url'),
                width: $G('width'),
                height: $G('height'),
                border: $G('border'),
                vhSpace: $G('vhSpace'),
                title: $G('title'),
                align: $G('align')
            };
            this.img = editor.selection.getRange().getClosedNode();
            this.img && this.setImage(this.img);
        },
        initEvents: function () {
            var _this = this,
                locker = $G('lock');

            /* 改变url */
            domUtils.on($G("url"), 'keyup', function(){updatePreview('url')});
            domUtils.on($G("border"), 'keyup', updatePreview);
            domUtils.on($G("title"), 'keyup', updatePreview);

            domUtils.on($G("width"), 'keyup', function(){
                updatePreview();
                if(locker.checked) {
                    var proportion =locker.getAttribute('data-proportion');
                    $G('height').value = Math.round(this.value / proportion);
                } else {
                    _this.updateLocker();
                }
            });
            domUtils.on($G("height"), 'keyup', function(){
                updatePreview();
                if(locker.checked) {
                    var proportion =locker.getAttribute('data-proportion');
                    $G('width').value = Math.round(this.value * proportion);
                } else {
                    _this.updateLocker();
                }
            });
            domUtils.on($G("lock"), 'change', function(){
                var proportion = parseInt($G("width").value) /parseInt($G("height").value);
                locker.setAttribute('data-proportion', proportion);
            });

            function updatePreview(type){
                setTimeout(()=>{
                    _this.setPreview(type);
                },0)
            }
        },
        updateLocker: function(){
            var width = $G('width').value,
                height = $G('height').value,
                lockicon = $G('lockicon'),
                locker = $G('lock');
            if(width && height && width>0 && height>0) {
                locker.disabled = false;
                locker.title =lockicon.title= lang.lockicon;
                // $('.lockicon-tip').html('');
            } else {
                locker.checked = false;
                locker.disabled = 'disabled';
                locker.title =lockicon.title= lang.remoteLockError;
                // $('.lockicon-tip').html(lang.remoteLockError);
            }
        },
        setImage: function(){
            /* 不是正常的图片 */
            if (!this.img.tagName || this.img.tagName.toLowerCase() != 'img' && !this.img.getAttribute("src") || !this.img.src) return;

            var wordImgFlag = this.img.getAttribute("word_img"),
                src = wordImgFlag ? wordImgFlag.replace("&amp;", "&") : (this.img.getAttribute('_src') || this.img.getAttribute("src", 2).replace("&amp;", "&")),
                align = editor.queryCommandValue("imageFloat");

            /* 防止onchange事件循环调用 */
            if (src !== $G("url").value) $G("url").value = src;
            if(src) {
                /* 设置表单内容 */
                $G("width").value = this.img.getAttribute("width") || $(this.img).width();
                $G("height").value = this.img.getAttribute("height") || $(this.img).height();
                $G("border").value = this.img.getAttribute("border") || '0';
                $G("vhSpace").value = this.img.getAttribute("vspace") || '0';
                $G("title").value = this.img.title || this.img.alt || '';
                setAlign(align);
                this.setPreview();
                this.updateLocker();
            }
        },
        getData: function(){
            var data = {};
            for(var k in this.dom){
                data[k] = this.dom[k].value;
            }
            return data;
        },
        setPreview: function(type){
            var url = $G('url').value,
                border = $G('border').value,
                title = $G('title').value,
                preview = $G('preview');
            if(url.substr(0,3)=='../') url=M.weburl+url.substr(3);
            if(url) {
                var is_new_url=url!=$(preview).find('img').attr('src');
                if(is_new_url) preview.innerHTML = '<img src="' + url + '"/>';
                $(preview).find('img').css({border:border + 'px solid #000',title:title});
                var handle=()=>{
                        var ow = $G('width').value,
                            oh = $G('height').value,
                            width=!ow? preview.offsetWidth:Math.min(ow, preview.offsetWidth),
                            height;
                        height = (!ow || !oh) ? '':width*oh/ow;
                        $(preview).find('img').attr({width:width,height:height});
                    }
                if(type=='url' && is_new_url){
                    var new_img_size=(img)=>{
                        $G("width").value = img.naturalWidth;
                        $G("height").value = img.naturalHeight;
                        handle();
                    }
                    var img=new Image();
                    img.src=url;
                    if (img.complete){
                        new_img_size(img);
                    }else{
                        img.onload=function(){
                            new_img_size(this);
                        };
                    }
                }else{
                    handle();
                }
            }
        },
        getInsertList: function () {
            var data = this.getData();
            if(data.url) {
                var $preview_img=$($G('preview')).find('img'),
                    new_size=($preview_img[0].naturalWidth!=parseInt(data.width||0)&&data.width)||($preview_img[0].naturalHeight!=parseInt(data.height||0)&&data.height);
                return [{
                    src: data.url,
                    _src: data.url,
                    width: new_size?data.width:'',
                    height: new_size?data.height:'',
                    border: data.border || '',
                    floatStyle: data.align || '',
                    vspace: data.vhSpace || '',
                    hspace: data.vhSpace || '',
                    title: data.title || '',
                    alt: data.title || '',
                    style:new_size? "width:" + data.width + "px;height:" + data.height + "px;":''
                }];
            } else {
                return [];
            }
        }
    };



    /* 上传图片 */
    function UploadImage(target) {
        this.$wrap = target.constructor == String ? $('#' + target) : $(target);
        this.init();
    }
    UploadImage.prototype = {
        init: function () {
            this.imageList = [];
            this.initUploader();
        },
        /* 初始化容器 */
        initUploader: function () {
            var _this = this,
                $ = jQuery,    // just in case. Make sure it's not an other libaray.
                $wrap = _this.$wrap,
            // 图片容器
                $queue = $wrap.find('.filelists'),
            // 状态栏，包括进度和控制按钮
                $statusBar = $wrap.find('.statusBar'),
            // 文件总体选择信息。
                $info = $statusBar.find('.info'),
            // 上传按钮
                $upload = $wrap.find('.uploadBtn'),
            // 上传按钮
                $filePickerBtn = $wrap.find('.filePickerBtn'),
            // 上传按钮
                $filePickerBlock = $wrap.find('.filePickerBlock'),
            // 没选择文件之前的内容。
                $placeHolder = $wrap.find('.placeholder'),
            // 总体进度条
                $progress = $statusBar.find('.progress').hide(),
            // 添加的文件数量
                fileCount = 0,
            // 添加的文件总大小
                fileSize = 0,
            // 优化retina, 在retina下这个值是2
                ratio = window.devicePixelRatio || 1,
            // 缩略图大小
                thumbnailWidth = 113 * ratio,
                thumbnailHeight = 113 * ratio,
            // 可能有pedding, ready, uploading, confirm, done.
                state = '',
            // 所有文件的进度信息，key为file id
                percentages = {},
                supportTransition = (function () {
                    var s = document.createElement('p').style,
                        r = 'transition' in s ||
                            'WebkitTransition' in s ||
                            'MozTransition' in s ||
                            'msTransition' in s ||
                            'OTransition' in s;
                    s = null;
                    return r;
                })(),
            // WebUploader实例
                uploader,
                actionUrl = editor.getActionUrl(editor.getOpt('imageActionName')),
                acceptExtensions = (editor.getOpt('imageAllowFiles') || []).join('').replace(/\./g, ',').replace(/^[,]/, ''),
                imageMaxSize = editor.getOpt('imageMaxSize'),
                imageCompressBorder = editor.getOpt('imageCompressBorder');

            if (!WebUploader.Uploader.support()) {
                $('#filePickerReady').after($('<div>').html(lang.errorNotSupport)).hide();
                return;
            } else if (!editor.getOpt('imageActionName')) {
                $('#filePickerReady').after($('<div>').html(lang.errorLoadConfig)).hide();
                return;
            }

            uploader = _this.uploader = WebUploader.create({
                pick: {
                    id: '#filePickerReady',
                    label: lang.uploadSelectFile
                },
                accept: {
                    title: 'Images',
                    extensions: acceptExtensions,
                    mimeTypes: 'image/*'
                },
                swf: '../../third-party/webuploader/Uploader.swf',
                server: actionUrl,
                fileVal: editor.getOpt('imageFieldName'),
                duplicate: true,
                fileSingleSizeLimit: imageMaxSize,    // 默认 2 M
                compress: editor.getOpt('imageCompressEnable') ? {
                    width: imageCompressBorder[0],
                    height: imageCompressBorder[1],
                    // 图片质量，只有type为`image/jpeg`的时候才有效。
                    quality: 90,
                    // 是否允许放大，如果想要生成小图的时候不失真，此选项应该设置为false.
                    allowMagnify: false,
                    // 是否允许裁剪。
                    crop: false,
                    // 是否保留头部meta信息。
                    preserveHeaders: true
                }:false
            });
            uploader.addButton({
                id: '#filePickerBlock'
            });
            uploader.addButton({
                id: '#filePickerBtn',
                label: lang.uploadAddFile
            });

            setState('pedding');

            // 当有文件添加进来时执行，负责view的创建
            function addFile(file) {
                var $li = $('<li id="' + file.id + '">' +
                        '<p class="title">' + file.name + '</p>' +
                        '<p class="imgWrap"></p>' +
                        '<p class="progress"><span></span></p>' +
                        '</li>'),

                    $btns = $('<div class="file-panel">' +
                        '<span class="cancel">' + lang.uploadDelete + '</span>' +
                        '<span class="rotateRight">' + lang.uploadTurnRight + '</span>' +
                        '<span class="rotateLeft">' + lang.uploadTurnLeft + '</span></div>').appendTo($li),
                    $prgress = $li.find('p.progress span'),
                    $wrap = $li.find('p.imgWrap'),
                    $info = $('<p class="error"></p>').hide().appendTo($li),

                    showError = function (code) {
                        switch (code) {
                            case 'exceed_size':
                                text = lang.errorExceedSize;
                                break;
                            case 'interrupt':
                                text = lang.errorInterrupt;
                                break;
                            case 'http':
                                text = lang.errorHttp;
                                break;
                            case 'not_allow_type':
                                text = lang.errorFileType+`，请设置<a href="${M.url.admin}#/safe/?head_tab_active=0" target="_blank">【允许上传的文件格式】</a>后刷新本页面</a>`;
                                break;
                            default:
                                text = lang.errorUploadRetry;
                                break;
                        }
                        $info.html(text).show();
                    };

                if (file.getStatus() === 'invalid') {
                    showError(file.statusText);
                } else {
                    $wrap.text(lang.uploadPreview);
                    if (browser.ie && browser.version <= 7) {
                        $wrap.text(lang.uploadNoPreview);
                    } else {
                        uploader.makeThumb(file, function (error, src) {
                            if (error || !src) {
                                $wrap.text(lang.uploadNoPreview);
                            } else {
                                var $img = $('<img src="' + src + '">');
                                $wrap.empty().append($img);
                                $img.on('error', function () {
                                    $wrap.text(lang.uploadNoPreview);
                                });
                            }
                        }, thumbnailWidth, thumbnailHeight);
                    }
                    percentages[ file.id ] = [ file.size, 0 ];
                    file.rotation = 0;

                    /* 检查文件格式 */
                    if (!file.ext || acceptExtensions.indexOf(file.ext.toLowerCase()) == -1) {
                        setTimeout(()=>{
                            showError('not_allow_type');
                        },100);
                        uploader.removeFile(file);
                    }
                }

                file.on('statuschange', function (cur, prev) {
                    if (prev === 'progress') {
                        $prgress.hide().width(0);
                    } else if (prev === 'queued') {
                        $li.off('mouseenter mouseleave');
                        $btns.remove();
                    }
                    // 成功
                    if (cur === 'error' || cur === 'invalid') {
                        showError(file.statusText);
                        percentages[ file.id ][ 1 ] = 1;
                    } else if (cur === 'interrupt') {
                        showError('interrupt');
                    } else if (cur === 'queued') {
                        percentages[ file.id ][ 1 ] = 0;
                    } else if (cur === 'progress') {
                        $info.hide();
                        $prgress.css('display', 'block');
                    } else if (cur === 'complete') {
                    }

                    $li.removeClass('state-' + prev).addClass('state-' + cur);
                });

                $li.on('mouseenter', function () {
                    $btns.stop().animate({height: 30});
                });
                $li.on('mouseleave', function () {
                    $btns.stop().animate({height: 0});
                });
                $btns.on('click', 'span', function () {
                    var index = $(this).index(),
                        deg;

                    switch (index) {
                        case 0:
                            uploader.removeFile(file);
                            return;
                        case 1:
                            file.rotation += 90;
                            break;
                        case 2:
                            file.rotation -= 90;
                            break;
                    }

                    if (supportTransition) {
                        deg = 'rotate(' + file.rotation + 'deg)';
                        $wrap.css({
                            '-webkit-transform': deg,
                            '-mos-transform': deg,
                            '-o-transform': deg,
                            'transform': deg
                        });
                    } else {
                        $wrap.css('filter', 'progid:DXImageTransform.Microsoft.BasicImage(rotation=' + (~~((file.rotation / 90) % 4 + 4) % 4) + ')');
                    }

                });

                $queue.append($li);
            }

            // 负责view的销毁
            function removeFile(file) {
                var $li = $('#' + file.id);
                delete percentages[ file.id ];
                updateTotalProgress();
                $li.off().find('.file-panel').off().end().remove();
            }

            function updateTotalProgress() {
                var loaded = 0,
                    total = 0,
                    spans = $progress.children(),
                    percent;

                $.each(percentages, function (k, v) {
                    total += v[ 0 ];
                    loaded += v[ 0 ] * v[ 1 ];
                });

                percent = total ? loaded / total : 0;

                spans.eq(0).text(Math.round(percent * 100) + '%');
                spans.eq(1).css('width', Math.round(percent * 100) + '%');
                updateStatus();
            }

            function setState(val, files) {

                if (val != state) {

                    var stats = uploader.getStats();

                    $upload.removeClass('state-' + state);
                    $upload.addClass('state-' + val);

                    switch (val) {

                        /* 未选择文件 */
                        case 'pedding':
                            $queue.addClass('element-invisible');
                            $statusBar.addClass('element-invisible');
                            $placeHolder.removeClass('element-invisible');
                            $progress.hide(); $info.hide();
                            uploader.refresh();
                            break;

                        /* 可以开始上传 */
                        case 'ready':
                            $placeHolder.addClass('element-invisible');
                            $queue.removeClass('element-invisible');
                            $statusBar.removeClass('element-invisible');
                            $progress.hide(); $info.show();
                            $upload.text(lang.uploadStart);
                            uploader.refresh();
                            break;

                        /* 上传中 */
                        case 'uploading':
                            $progress.show(); $info.hide();
                            $upload.text(lang.uploadPause);
                            break;

                        /* 暂停上传 */
                        case 'paused':
                            $progress.show(); $info.hide();
                            $upload.text(lang.uploadContinue);
                            break;

                        case 'confirm':
                            $progress.show(); $info.hide();
                            $upload.text(lang.uploadStart);

                            stats = uploader.getStats();
                            if (stats.successNum && !stats.uploadFailNum) {
                                setState('finish');
                                return;
                            }
                            break;

                        case 'finish':
                            $progress.hide(); $info.show();
                            if (stats.uploadFailNum) {
                                $upload.text(lang.uploadRetry);
                            } else {
                                $upload.text(lang.uploadStart);
                            }
                            break;
                    }

                    state = val;
                    updateStatus();

                }

                if (!_this.getQueueCount()) {
                    $upload.addClass('disabled')
                } else {
                    $upload.removeClass('disabled')
                }

            }

            function updateStatus() {
                var text = '', stats;

                if (state === 'ready') {
                    text = lang.updateStatusReady.replace('_', fileCount).replace('_KB', WebUploader.formatSize(fileSize));
                } else if (state === 'confirm') {
                    stats = uploader.getStats();
                    if (stats.uploadFailNum) {
                        text = lang.updateStatusConfirm.replace('_', stats.successNum).replace('_', stats.successNum);
                    }
                } else {
                    stats = uploader.getStats();
                    text = lang.updateStatusFinish.replace('_', fileCount).
                        replace('_KB', WebUploader.formatSize(fileSize)).
                        replace('_', stats.successNum);

                    if (stats.uploadFailNum) {
                        text += lang.updateStatusError.replace('_', stats.uploadFailNum);
                    }
                }

                $info.html(text);
            }

            uploader.on('fileQueued', function (file) {
                fileCount++;
                fileSize += file.size;

                if (fileCount === 1) {
                    $placeHolder.addClass('element-invisible');
                    $statusBar.show();
                }

                addFile(file);
                // 上传图片列表拖拽排序
                if(!$('.dragsort-js').length){
                    $('body').append(`<script type="text/javascript" class='dragsort-js' src="../../../dragsort/jquery.dragsort.js"></script>`);
                    var interval=setInterval(()=>{
                        if(typeof $.fn.dragsort!='undefined'){
                            clearInterval(interval);
                            $queue.dragsort({
                                dragSelector: $queue.data('drag_selector'),
                                dragBetween: false ,// 设置为“true”，如果你要启用多组列表之间拖动选定的列表。 默认值是false。
                                dragSelectorExclude:typeof $queue.data('drag_selector_exclude')!='undefined'?$queue.data('drag_selector_exclude'):'input,textarea,select,a,i,span,button,.minicolors-panel',
                            });
                        }
                    },200);
                    $statusBar.find('.upload-tips').text(lang.dragImage);
                }
            });

            uploader.on('fileDequeued', function (file) {
                fileCount--;
                fileSize -= file.size;

                removeFile(file);
                updateTotalProgress();
            });

            uploader.on('filesQueued', function (file) {
                if (!uploader.isInProgress() && (state == 'pedding' || state == 'finish' || state == 'confirm' || state == 'ready')) {
                    setState('ready');
                }
                updateTotalProgress();
            });

            uploader.on('all', function (type, files) {
                switch (type) {
                    case 'uploadFinished':
                        setState('confirm', files);
                        break;
                    case 'startUpload':
                        /* 添加额外的GET参数 */
                        var params = utils.serializeParam(editor.queryCommandValue('serverparam')) || '',
                            url = utils.formatUrl(actionUrl + (actionUrl.indexOf('?') == -1 ? '?':'&') + 'encode=utf-8&' + params);
                        uploader.option('server', url);
                        setState('uploading', files);
                        break;
                    case 'stopUpload':
                        setState('paused', files);
                        break;
                }
            });

            uploader.on('uploadBeforeSend', function (file, data, header) {
                //这里可以通过data对象添加POST参数
                header['X_Requested_With'] = 'XMLHttpRequest';
            });

            uploader.on('uploadProgress', function (file, percentage) {
                var $li = $('#' + file.id),
                    $percent = $li.find('.progress span');

                $percent.css('width', percentage * 100 + '%');
                percentages[ file.id ][ 1 ] = percentage;
                updateTotalProgress();
            });

            uploader.on('uploadSuccess', function (file, ret) {
                var $file = $('#' + file.id);
                try {
                    var responseText = (ret._raw || ret),
                        json = utils.str2json(responseText);
                    if (json.state == 'SUCCESS') {
                        json.id=file.id;
                        _this.imageList.push(json);
                        $file.append('<span class="success"></span>');
                    } else {
                        $file.find('.error').text(json.state).show();
                    }
                } catch (e) {
                    $file.find('.error').text(lang.errorServerUpload).show();
                }
            });

            uploader.on('uploadError', function (file, code) {
            });
            uploader.on('error', function (code, file) {
                if (code == 'Q_TYPE_DENIED' || code == 'F_EXCEED_SIZE') {
                    addFile(file);
                }
            });
            uploader.on('uploadComplete', function (file, ret) {
            });

            $upload.on('click', function () {
                if ($(this).hasClass('disabled')) {
                    return false;
                }

                if (state === 'ready') {
                    uploader.upload();
                } else if (state === 'paused') {
                    uploader.upload();
                } else if (state === 'uploading') {
                    uploader.stop();
                }
            });

            $upload.addClass('state-' + state);
            updateTotalProgress();
        },
        getQueueCount: function () {
            var file, i, status, readyFile = 0, files = this.uploader.getFiles();
            for (i = 0; file = files[i++]; ) {
                status = file.getStatus();
                if (status == 'queued' || status == 'uploading' || status == 'progress') readyFile++;
            }
            return readyFile;
        },
        destroy: function () {
            this.$wrap.remove();
        },
        getInsertList: function () {
            var i, data, list = [],
                align = getAlign(),
                prefix = editor.getOpt('imageUrlPrefix');
            for (i = 0; i < this.imageList.length; i++) {
                data = this.imageList[i];
                list[$('#' + data.id).index()]={
                    src: prefix + data.url,
                    _src: prefix + data.url,
                    title: data.title,
                    alt: data.original,
                    floatStyle: align,
                    'data-width':data.width,
                    'data-height':data.height
                };
            }
            return list;
        }
    };


    /* 在线图片 */
    function OnlineImage(target) {
        this.container = utils.isString(target) ? document.getElementById(target) : target;
        this.init();
    }
    OnlineImage.prototype = {
        imgList:function(result){
            var html = '';
            $.each(result, function(index, val) {
                if(val.type=='dir'){
                    html+='<li><a href="javascript:;" data-path="'+val.path+'"><i class="fa-folder-open-o"></i><h4>'+val.name+'</h4></a></li>';
                }else{
                    html += '<li class="img-item" title="'+val.name+'"><img '+(index>14?'data-original':'src')+'="'+M.weburl+val.path+'" data-path="'+val.value+'"><span class="icon"></span><a href="'+M.url.admin+val.value+'" title="'+METLANG.View+METLANG.image+'" target="_blank" class="view"><i class="fa-search-plus"></i></a></li>';
                }
            });
            return html;
        },
        init: function () {
            var _this = this;
            $('#online .online-tips').html(METLANG.enter_folder);
            // 文件夹绑定双击事件-加载图片列表
            $(document).on('dblclick', '#imageList li a,#online .online-breadcrumb a', function(event) {
                if(!$('#lazyload-js').length){
                    $('html').append('<script src="'+M.url.public_plugins+'jquery-lazyload/jquery.lazyload.min.js" id="lazyload-js"></script>');
                }
                var dir=$(this).data('path');
                top.$.ajax({
                    url: M.url.admin + 'index.php?n=system&c=filept&a=doGetFileList',
                    data: {dir: dir,sort:$('.alignBar-online a.active').data('type')},
                    success:function(result){
                        if (result) {
                            var html = _this.imgList(result);
                            !html && (html='<div style="height: 100%;line-height:355px;text-align: center;font-size:20px;">'+METLANG.nopicture+'</div>');
                            $('#imageList').html(html);
                            $('#imageList [data-original]').lazyload({
                                container: '#imageList'
                            });
                        }
                    }
                });
                // 图片路径面包屑
                var breadcrumb=[],
                    breadcrumb_path='';
                $.each(dir.split('/'), function(index, val) {
                    if(index){
                        breadcrumb.push('<a href="javascript:;" '+(index==1?'':'data-path="'+breadcrumb_path+'/'+val+'"')+'>'+val+'</a>');
                        breadcrumb_path+='/'+val;
                    }
                });
                breadcrumb='/ '+breadcrumb.join(' / ')+' /';
                $('#online .online-breadcrumb').show().html(breadcrumb);
            });
            // 点击排序
            $(document).on('click clicks', '.alignBar-online a', function(event) {
                $(this).addClass('active').siblings('a').removeClass('active');
                if(event.type=='click'){
                    $('.online-breadcrumb').is(':visible')?$('.online-breadcrumb a:last-child').dblclick():setTabFocus('online');
                    setCookie('ueditor-onlineimages-sort',$(this).data('type'),setCookie?'':{path:'/',expires:365},'365');
                }
            });

            var sort=getCookie('ueditor-onlineimages-sort');
            sort && $('.alignBar-online a[data-type="'+sort+'"]').trigger('clicks');
            this.reset();
            this.initEvents();
        },
        /* 初始化容器 */
        initContainer: function () {
            this.container.innerHTML = '';
            this.list = document.createElement('ul');
            this.clearFloat = document.createElement('li');

            domUtils.addClass(this.list, 'list');
            domUtils.addClass(this.clearFloat, 'clearFloat');

            this.list.appendChild(this.clearFloat);
            this.container.appendChild(this.list);
        },
        /* 初始化滚动事件,滚动到地步自动拉取数据 */
        initEvents: function () {
            var _this = this;
            /* 选中图片 */
            $('#imageList').on('click', 'li.img-item', function(event) {
                $(this).toggleClass('selected');
            });
        },
        /* 初始化第一次的数据 */
        initData: function () {
            /* 拉取数据需要使用的值 */
            this.state = 0;
            this.listSize = editor.getOpt('imageManagerListSize');
            this.listIndex = 0;
            this.listEnd = false;

            /* 第一次拉取数据 */
            this.getImageData();
        },
        /* 重置界面 */
        reset: function() {
            this.initContainer();
            this.initData();
        },
        /* 向后台拉取图片列表数据 */
        getImageData: function () {
            if(!this.online_load){
                this.online_load=1;
                var _this = this,
                    url = M.url.admin + 'index.php?n=system&c=filept&a=doGetFileList&sort='+$('.alignBar-online a.active').data('type');
                ajax.request(url, {
                    'dataType': 'json',
                    'method': 'post',
                    'onsuccess': function (r) {
                        var json = eval('(' + r.responseText + ')'),
                            html=_this.imgList(json);
                        $(_this.list).html(html);
                        $('#online .online-breadcrumb').hide().html('');
                    },
                    'onerror': function (r) {
                        M.load?M.load('alertify',function(){
                            top.alertify.error('error');
                        }):alert('error');
                    }
                });
                setTimeout(function(){
                    _this.online_load=0;
                },500)
            }
        },
        getInsertList: function () {
            var list = [];
            $('#imageList li.selected img').each(function(index, el) {
                var src=$(this).data('path');
                list.push({
                    src: src,
                    _src: src,
                    floatStyle: 'center',
                    'data-width':this.naturalWidth,
                    'data-height':this.naturalHeight
                });
            });
            return list;
        }
    };
})();